/*
This is part of Screenbar, which is based in part on the Litestep
shell source code.

Copyright (C) 2008-2009 Jim Babcock
Copyright (C) 1997-2009 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "stdafx.h"

GroupElement::GroupElement(string prefix)
	:LayoutElement(prefix)
{
	string elementList = getConfigLine("Elements", NULL, prefix.c_str());
	layoutPool->parseElementList(elementList, &children);
	baseLength = getConfigInt("BaseLength", 0, prefix.c_str());
}

GroupElement::~GroupElement()
{
}

ElementSize GroupElement::getLength(const LayoutCacheNode *node)
{
	ElementSize ret;
	ret.minimum = 0;
	ret.preferred = 0;
	
	for(unsigned ii=0; ii<node->children.size(); ii++)
	{
		LayoutCacheNode *child = node->children[ii];
		if(child->size.minimum > ret.minimum)
			ret.minimum = child->size.minimum;
		if(child->size.preferred > ret.preferred)
			ret.preferred = child->size.preferred;
	}
	
	ret.minimum += baseLength;
	ret.preferred += baseLength;
	return ret;
}

void GroupElement::getChildren(LayoutCacheNode *node, vector<LayoutLocation> &outChildren)
{
	for(unsigned ii=0; ii<children.size(); ii++)
	{
		LayoutLocation loc;
			loc.element = children[ii];
			loc.context = node->context;
		outChildren.push_back(loc);
	}
}
