/*
This is part of Screenbar, which is based in part on the Litestep
shell source code.

Copyright (C) 2008-2009 Jim Babcock
Copyright (C) 1997-2009 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "stdafx.h"

bool hoverTrackingEnabled = false;
HWND hoveredWindow = NULL;


TaskData *getHoveredTask()
{
	if(!hoveredWindow) return NULL;
	WindowData *window = windowTracker->getWindow(hoveredWindow);
	if(!window) return NULL;
	return window->task;
}

void enableHoverTracking()
{
	hoverTrackingEnabled = true;
}

void updateHover()
{
	if(!hoverTrackingEnabled)
		return;
	Point cursorPos = getCursorPos();
	
	HWND newHoveredWindow = WindowFromPoint(cursorPos);
	while(1) {
		HWND parent = GetParent(newHoveredWindow);
		if(!parent) break;
		newHoveredWindow = parent;
	}
	
	if(newHoveredWindow != hoveredWindow)
	{
		hoveredWindow = newHoveredWindow;
		for(unsigned ii=0; ii<panels.size(); ii++)
			panels[ii]->checkForUpdates();
	}
}

