/*
This is part of Screenbar, which is based in part on the Litestep
shell source code.

Copyright (C) 2008-2009 Jim Babcock
Copyright (C) 1997-2009 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#pragma once

class Monitor
	:public DeskSlot
{
public:
	Monitor(HMONITOR handle, string name, Rect boundingRect);
	~Monitor();
	void updateFrom(Monitor *newMonitor);
	
	VirtualDesktop *getDesk();
	void setDesk(VirtualDesktop *desk);
	Rect getRect() const;
	int getOverlapArea(Rect &rect);
	Rect getMaximizeArea();
	string getName();
	vector<ScreenbarPanel*> getPanelsOnMonitor();
	
	bool visited;
	
protected:
	friend class MonitorPool;
	
	HMONITOR handle;
	Rect boundingRect;
	string name;
	VirtualDesktop *currentDesk;
};

class MonitorPool
{
public:
	MonitorPool();
	~MonitorPool();
	
	void refresh();
	
	int numMonitors();
	vector<Monitor*> findMonitor(Rect windowPos);
	Monitor *findMonitor(Point cursorPos);
	Monitor *getMonitor(int index);
	Monitor *getPrimaryMonitor();
	
private:
	vector<Monitor*> monitors;
};
extern MonitorPool *monitors;
