/*
This is part of Screenbar, which is based in part on the Litestep
shell source code.

Copyright (C) 2008-2009 Jim Babcock
Copyright (C) 1997-2009 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#pragma once

#define TIMER_POLL 1
#define TIMER_HOVERTRACK 2
#define TIMER_AUTOHIDE 3
#define TIMER_DRAGFOLLOW 4
#define TIMER_ANIMATEWINDOW 5
#define TIMER_ANIMATELAYOUT 6

#define UMSG_APPBAR        (WM_USER+0)
#define UMSG_REFRESHLAYOUT (WM_USER+1)
#define UMSG_UPDATEOVERLAY (WM_USER+2)

#define ANIM_CREATE 1
#define ANIM_DESTROY 2
#define ANIM_SHOW 3
#define ANIM_HIDE 4

// savestate.cpp
void saveState();
bool restoreState();

// hovertracking.cpp
TaskData *getHoveredTask();
void enableHoverTracking();
void updateHover();

extern bool hoverTrackingEnabled;
extern HWND hoveredWindow;

// events.cpp
LRESULT globalWindowProc(HWND window, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT onSwitchToN(WPARAM wParam, LPARAM lParam);
LRESULT onListDesktops(WPARAM wParam, LPARAM lParam);
LRESULT onGetDesktopOf(WPARAM wParam, LPARAM lParam);

// statsclass.cpp
string statsClassEval(string str, const ElementContext *context);

// module.cpp
extern HWND parentWindow;
extern HINSTANCE dllInstance;
extern string modulePath;

extern "C"
{
	__declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
	__declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}
